﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=10.6
@EndOfDesignText@
' ################################################
' Custom View Rich Text Editor
' ------------------------------------------------
' Version:		1.1
' Name:			RTF_Editor
' Type:			B4Xlib - B4A
' Designer:		Yes
' Libs:			B4XCollections, Core, IME, XUI, XUI views
'				SMMRichEditor
' Files:		Editor.html, normalize.css, rich_editor.js
'				style.css
' Layout:		Layout, RTFEditor
' ------------------------------------------------
' (C)			SMMRichEditor: somed3v3loper
' (C)			TechDoc G. Becker
' NOTICE!		Free to use for Board menbers only!
' ################################################

#region --- Update Log ---
' 15.1.2021 1.0 Alpha 1st release
' 16.1.2021 1.1 Alpha
'	- added editor to scrollview
#end region

' ################################################

#region --- Designer Properties & Events
#Event: TextChanged (HTML as string)

#end region

' ################################################

#region --- view basics
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Public mBase As B4XView
	Private xui As XUI 'ignore
	Public Tag As Object
	Private ime As IME
	Private ColorTemplate As B4XColorTemplate
	Private Dialog As B4XDialog
	Public EditorText As String
		
	Private pnlHeader As Panel
	Private btBold As SwiftButton
	Private btItalic As SwiftButton
	Private btTextColor As SwiftButton
	Private btFeatures As SwiftButton
	Private lblTextSize As B4XView
	Private btSizeList As SwiftButton
	Private clvSizeValues As ListView
	Private pnlSizeValues As B4XView
	
	Private pnlFeatures As Panel
	
	Private pnlEditor As Panel
	Private RTE As SMMRichEditor
	Private scvEditor As ScrollView
End Sub

Public Sub Initialize (Callback As Object, EventName As String)
	mEventName = EventName
	mCallBack = Callback
	RTE.Initialize("RTE")
	ColorTemplate.Initialize
	ime.Initialize("")
End Sub

'Base type must be Object
Public Sub DesignerCreateView (Base As Object, Lbl As Label, Props As Map)
	mBase = Base
    Tag = mBase.Tag
    mBase.Tag = Me
		
	' wait until startup activities finished
	CallSubDelayed(Me, "AfterLoadLayout")
End Sub

Public Sub AfterLoadLayout()
	' load editor layout
	mBase.LoadLayout("RTFEditor")
	
	' add SMMRichEditor view to layout (not possible direct in designer!)
	scvEditor.Initialize(pnlEditor.Height)
	RTE.AddToParent(scvEditor.panel,0,0,pnlEditor.Width,pnlEditor.height)
	pnlEditor.AddView(scvEditor,10dip,10dip,pnlEditor.Width-20,pnlEditor.height-20)
	
	' set size value list
	clvSizeValues.SingleLineLayout.Label.TextSize=14
	clvSizeValues.Color=xui.Color_LightGray
	clvSizeValues.SingleLineLayout.Label.Textcolor=Colors.Black
	For x = 8 To 72 Step 2
		clvSizeValues.AddSingleLine(x)
	Next
	clvSizeValues.SetSelection(3)
	
	' set other parameter
	RTE.EditorFontSize=14
	RTE.focusEditor
	lblTextSize.Text=14
End Sub

Private Sub Base_Resize (Width As Double, Height As Double)
  
End Sub
#end region
' ################################################

#region --- click ---
' Header Buttons
Private Sub btBold_Click
	RTE.setBold
End Sub

Private Sub btSizeList_Click
	pnlSizeValues.Visible=Not(pnlSizeValues.visible)
End Sub


Private Sub btTextColor_Click
	ime.HideKeyboard
	If Dialog.IsInitialized = False Then Dialog.Initialize(mBase.Parent)
	Wait For (Dialog.ShowTemplate(ColorTemplate, "OK", "", "")) Complete (Result As Int)
	If Result = xui.DialogResponse_Positive Then
		RTE.EditorFontColor=ColorTemplate.SelectedColor
		RTE.focusEditor
	End If
	pnlFeatures.Visible=False
End Sub

Private Sub btUndo_Click
	RTE.undo
	RTE.focusEditor
End Sub

Private Sub btUnderline_Click
	RTE.setUnderline
	pnlFeatures.Visible=False
End Sub

Private Sub btItalic_Click
	RTE.setItalic
	pnlFeatures.Visible=False
End Sub

Private Sub btFeatures_Click
	pnlFeatures.Visible=Not(pnlFeatures.Visible)
End Sub


' Features Buttons

Private Sub btSuper_Click
	RTE.setSuperscript
	pnlFeatures.Visible=False
End Sub

Private Sub btSub_Click
	RTE.setSubscript
	pnlFeatures.Visible=False
End Sub

Private Sub btAlignLeft_Click
	RTE.setAlignLeft
	pnlFeatures.Visible=False
End Sub

Private Sub btAlignCenter_Click
	RTE.setAlignCenter
	pnlFeatures.Visible=False
End Sub

Private Sub btAlignRight_Click
	RTE.setAlignRight
	pnlFeatures.Visible=False
End Sub

Private Sub btIndent_Click
	RTE.setIndent
	pnlFeatures.Visible=False
End Sub

Private Sub btOutdent_Click
	RTE.setOutdent
	pnlFeatures.Visible=False
End Sub

Private Sub btStrike_Click
	RTE.setStrikeThrough
	pnlFeatures.Visible=False
End Sub

Private Sub btCheck_Click
	RTE.insertTodo
End Sub

Private Sub btBullet_Click
	RTE.setBullets
	pnlFeatures.Visible=False
End Sub

Private Sub btNumbers_Click
	RTE.setnumbers
	pnlFeatures.Visible=False
End Sub
Private Sub pnlHeader_Click
	ime.HideKeyboard
End Sub

' panel
Private Sub pnlFeatures_Click
	pnlFeatures.visible=False
End Sub
#end region

' ################################################

#region --- RTE ---
private Sub RTE_textchanged (new As String)
	EditorText = new
	If xui.SubExists(mCallBack, mEventName & "_TextChanged",0) Then
		CallSub2(mCallBack,mEventName & "_TextChanged",new)
	End If
End Sub

public Sub setEditorHTMLText(HTML As String)
	EditorText=HTML
	RTE.Html=HTML
End Sub
#end region

' ################################################

#region --- Listview ---
Private Sub clvSizeValues_ItemClick (Index As Int, Value As Object)
	RTE.EditorFontSize= Value
	lblTextSize.Text=Value
	pnlSizeValues.Visible=False
End Sub
#end region






